Index: /extensions/gvideo/admin.php
===================================================================
--- /extensions/gvideo/admin.php	(revision 17307)
+++ /extensions/gvideo/admin.php	(revision 17307)
@@ -0,0 +1,31 @@
+<?php
+if (!defined('GVIDEO_PATH')) die('Hacking attempt!');
+
+global $template, $page, $conf;
+
+$conf['gvideo'] = unserialize($conf['gvideo']);
+load_language('plugin.lang', GVIDEO_PATH);
+
+// tabsheet
+include_once(PHPWG_ROOT_PATH.'admin/include/tabsheet.class.php');
+$page['tab'] = (isset($_GET['tab'])) ? $_GET['tab'] : $page['tab'] = 'add';
+  
+$tabsheet = new tabsheet();
+$tabsheet->add('add', l10n('Add a video'), GVIDEO_ADMIN . '-add');
+$tabsheet->add('config', l10n('Configuration'), GVIDEO_ADMIN . '-config');
+$tabsheet->select($page['tab']);
+$tabsheet->assign();
+
+// include page
+include(GVIDEO_PATH . 'admin/' . $page['tab'] . '.php');
+
+// template
+$template->assign(array(
+  'GVIDEO_PATH'=> GVIDEO_PATH,
+  'GVIDEO_ABS_PATH'=> dirname(__FILE__).'/',
+  'GVIDEO_ADMIN' => GVIDEO_ADMIN,
+  ));
+  
+$template->assign_var_from_handle('ADMIN_CONTENT', 'gvideo_content');
+
+?>
Index: /extensions/gvideo/admin/add.php
===================================================================
--- /extensions/gvideo/admin/add.php	(revision 17307)
+++ /extensions/gvideo/admin/add.php	(revision 17307)
@@ -0,0 +1,146 @@
+<?php
+if (!defined('GVIDEO_PATH')) die('Hacking attempt!');
+
+include_once(GVIDEO_PATH.'include/functions.inc.php');
+include_once(PHPWG_ROOT_PATH . 'admin/include/functions_upload.inc.php');
+
+if (isset($_POST['add_video']))
+{
+  // check inputs
+  if (empty($_POST['url']))
+  {
+    array_push($page['errors'], l10n('Please fill the video URL'));
+  }
+  if ($_POST['name_server'] == 'false' and empty($_POST['name']))
+  {
+    array_push($page['errors'], l10n('Please fill the video name'));
+  }
+  if ($_POST['thumbnail_server'] == 'false' and empty($_FILES['thumbnail_src']))
+  {
+    array_push($page['errors'], l10n('Please add a thumbnail'));
+  }
+  if ( !empty($_POST['url']) and ($video = parse_video_url($_POST['url'])) === false )
+  {
+    array_push($page['errors'], l10n('Unable to contact host server'));
+  }
+  
+  if (count($page['errors']) == 0)
+  {
+    // download thumbnail
+    $thumb_name = $video['type'].'-'.$video['id'].'-'.uniqid();
+    if ($_POST['thumbnail_server'] == 'true')
+    {
+      $thumb_name.= '.'.get_extension($video['thumbnail']);
+      $thumb_source = $conf['data_location'].$thumb_name;
+      if (download_remote_file($video['thumbnail'], $thumb_source) !== true)
+      {
+        $thumb_source = $conf['data_location'].get_filename_wo_extension($thumb_name).'.jpg';
+        copy(GVIDEO_PATH.'mimetypes/'.$video['type'].'.jpg', $thumb_source);
+      }
+    }
+    // upload thumbnail
+    else
+    {
+      if ($_FILES['thumbnail_src']['error'] > 0) 
+      {
+        array_push($page['errors'], l10n('Unknown upload error'));
+      }
+      else if ( !in_array($_FILES['thumbnail_src']['type'], array('image/jpeg','image/png','image/gif')) )
+      {
+        array_push($page['errors'], l10n('Incorrect file type,').' '.sprintf(l10n('Allowed file types: %s.'), 'jpg, png, gif'));
+      }
+      
+      $thumb_name.= '.'.get_extension($_FILES['thumbnail_src']['name']);
+      $thumb_source = $_FILES['thumbnail_src']['tmp_name'];
+    }
+    
+    if (count($page['errors']) == 0)
+    {
+      // add image and update infos
+      $image_id = add_uploaded_file($thumb_source, $thumb_name, array($_POST['category']));
+      
+      if ($_POST['name_server'] == 'true')        $_POST['name'] = $video['title'];
+      if ($_POST['description_server'] == 'true') $_POST['description'] = $video['description'];
+      if ($_POST['author_server'] == 'true')      $_POST['author'] = $video['author'];
+      
+      $updates = array(
+        'name' => pwg_db_real_escape_string($_POST['name']),
+        'comment' => pwg_db_real_escape_string(@$_POST['description']),
+        'author' => pwg_db_real_escape_string(@$_POST['author']),
+        );
+      
+      single_update(
+        IMAGES_TABLE,
+        $updates,
+        array('id' => $image_id),
+        true
+        );
+      
+      // register video
+      if ($_POST['size_common'] == 'true')
+      {
+        $_POST['width'] = $_POST['height'] = '';
+      }
+      if ($_POST['autoplay_common'] == 'true')
+      {
+        $_POST['autoplay'] = '';
+      }
+      
+      $insert = array(
+        'picture_id' => $image_id,
+        'type' => $video['type'],
+        'video_id' => $video['id'],
+        'width' => $_POST['width'],
+        'height' => $_POST['height'],
+        'autoplay' => $_POST['autoplay'],
+        );
+        
+      single_insert(
+        GVIDEO_TABLE,
+        $insert
+        );
+        
+      array_push($page['infos'], sprintf(
+        l10n('Video successfully added. <a href="%s">View</a>'), 
+        make_picture_url(array(
+          'image_id' => $image_id,
+          'category' => array(
+            'id' => $_POST['category'],
+            'name' => '',
+            'permalink' => '',
+            ),
+          ))
+        ));
+      unset($_POST);
+    }
+  }
+}
+
+// categories
+$query = '
+SELECT id,name,uppercats,global_rank
+  FROM '.CATEGORIES_TABLE.'
+;';
+display_select_cat_wrapper($query, array(), 'category_parent_options');
+
+// upload limit
+$upload_max_filesize = min(
+  get_ini_size('upload_max_filesize'),
+  get_ini_size('post_max_size')
+  );
+$upload_max_filesize_shorthand = 
+  ($upload_max_filesize == get_ini_size('upload_max_filesize')) ?
+  get_ini_size('upload_max_filesize', false) :
+  get_ini_size('post_max_filesize', false);
+  
+// template
+$template->assign(array(
+  'upload_max_filesize' => $upload_max_filesize,
+  'upload_max_filesize_shorthand' => $upload_max_filesize_shorthand,
+  'gvideo' => $conf['gvideo'],
+  'POST' => @$_POST,
+  ));
+
+$template->set_filename('gvideo_content', dirname(__FILE__) . '/template/add.tpl');
+
+?>
Index: /extensions/gvideo/admin/config.php
===================================================================
--- /extensions/gvideo/admin/config.php	(revision 17306)
+++ /extensions/gvideo/admin/config.php	(revision 17307)
@@ -1,116 +1,41 @@
 <?php
+if (!defined('GVIDEO_PATH')) die('Hacking attempt!');
 
-if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');
-
-// Chargement des parametres
-$params = unserialize($conf['PY_GVideo']);
-
-// Mise a jour de la base de donnee
-if (isset($_POST['submit']))
+if (isset($_POST['save_config']))
 {
-  $params  = array(
-    'gvideo' => array(
-      $_POST['pywaie_gvideo_h'],
-      $_POST['pywaie_gvideo_w'],
-      $_POST['pywaie_gvideo_autoplay'],
-      $_POST['pywaie_gvideo_hl']),
-    'ytube' => array(
-      $_POST['pywaie_ytube_h'],
-      $_POST['pywaie_ytube_w'],
-      $_POST['pywaie_ytube_autoplay']),
-    'dm' => array(
-      $_POST['pywaie_dm_h'],
-      $_POST['pywaie_dm_w'],
-      $_POST['pywaie_dm_autoplay']),
-    'wideo' => array(
-      $_POST['pywaie_wideo_h'],
-      $_POST['pywaie_wideo_w'],
-      $_POST['pywaie_wideo_autoplay']),
+  $conf['gvideo'] = array(
+    'autoplay' => $_POST['autoplay'],
+    'width' => $_POST['width'],
+    'height' => $_POST['height'],
     'vimeo' => array(
-      $_POST['pywaie_vimeo_h'],
-      $_POST['pywaie_vimeo_w'],
-      $_POST['pywaie_vimeo_autoplay']),
-    'wat' => array(
-      $_POST['pywaie_wat_h'],
-      $_POST['pywaie_wat_w'],
-      $_POST['pywaie_wat_autoplay'])
+      'title' => (int)isset($_POST['vimeo']['title']),
+      'portrait' => (int)isset($_POST['vimeo']['portrait']),
+      'byline' => (int)isset($_POST['vimeo']['byline']),
+      'color' => $_POST['vimeo']['color'],
+      ),
+    'dailymotion' => array(
+      'logo' => (int)isset($_POST['dailymotion']['logo']),
+      'title' => (int)isset($_POST['dailymotion']['title']),
+      'color' => $_POST['dailymotion']['color'],
+      ),
+    'youtube' => array(),
+    'wat' => array(),
+    'wideo' => array(),
+    'videobb' => array(),
     );
-  
-  $query = '
-UPDATE ' . CONFIG_TABLE . '
-  SET value="' . addslashes(serialize($params)) . '"
-  WHERE param="PY_GVideo"
-  LIMIT 1';
-  pwg_query($query);
-  
-  array_push($page['infos'], l10n('py_info4'));
+      
+  conf_update_param('gvideo', serialize($conf['gvideo']));
+  array_push($page['infos'], l10n('Information data registered in database'));
 }
 
+
 $template->assign(array(
-  'PYWAIE_GVIDEO_H' => $params['gvideo'][0],
-  'PYWAIE_GVIDEO_W' => $params['gvideo'][1],
-  'PYWAIE_GVIDEO_HL' => $params['gvideo'][3],
-  'PYWAIE_YTUBE_H' => $params['ytube'][0],
-  'PYWAIE_YTUBE_W' => $params['ytube'][1],
-  'PYWAIE_DM_H' => $params['dm'][0],
-  'PYWAIE_DM_W' => $params['dm'][1],
-  'PYWAIE_WIDEO_H' => $params['wideo'][0],
-  'PYWAIE_WIDEO_W' => $params['wideo'][1],
-  'PYWAIE_VIMEO_H' => $params['vimeo'][0],
-  'PYWAIE_VIMEO_W' => $params['vimeo'][1],
-  'PYWAIE_WAT_H' => $params['wat'][0],
-  'PYWAIE_WAT_W' => $params['wat'][1]));
+  'gvideo' => $conf['gvideo'],
+  'vimeo_colors' => array('00adef', 'ff9933', 'c9ff23', 'ff0179', 'ffffff'),
+  'dailymotion_colors' => array('F7FFFD', 'E02C72', '92ADE0', 'E8D9AC', 'C2E165', '052880', 'FF0000', '834596'),
+  ));
 
-if ($params['gvideo'][2] == 'true')
-{
-  $template->assign(array('PYWAIE_GVIDEO_AUTOPLAY_TRUE' => 'checked="checked"'));
-}
-else
-{
-  $template->assign(array('PYWAIE_GVIDEO_AUTOPLAY_FALSE' => 'checked="checked"'));
-}
-if ($params['ytube'][2] == '1')
-{
-  $template->assign(array('PYWAIE_YTUBE_AUTOPLAY_TRUE' => 'checked="checked"'));
-}
-else
-{
-  $template->assign(array('PYWAIE_YTUBE_AUTOPLAY_FALSE' => 'checked="checked"'));
-}
-if ($params['dm'][2] == '1')
-{
-  $template->assign(array('PYWAIE_DM_AUTOPLAY_TRUE' => 'checked="checked"'));
-}
-else
-{
-  $template->assign(array('PYWAIE_DM_AUTOPLAY_FALSE' => 'checked="checked"'));
-}
-if ($params['wideo'][2] == 'true')
-{
-  $template->assign(array('PYWAIE_WIDEO_AUTOPLAY_TRUE' => 'checked="checked"'));
-}
-else
-{
-  $template->assign(array('PYWAIE_WIDEO_AUTOPLAY_FALSE' => 'checked="checked"'));
-}
-if ($params['vimeo'][2] == '1')
-{
-  $template->assign(array('PYWAIE_VIMEO_AUTOPLAY_TRUE' => 'checked="checked"'));
-}
-else
-{
-  $template->assign(array('PYWAIE_VIMEO_AUTOPLAY_FALSE' => 'checked="checked"'));
-}
-if ($params['wat'][2] == 'true')
-{
-  $template->assign(array('PYWAIE_WAT_AUTOPLAY_TRUE' => 'checked="checked"'));
-}
-else
-{
-  $template->assign(array('PYWAIE_WAT_AUTOPLAY_FALSE' => 'checked="checked"'));
-}
 
-$template->set_filenames(array('plugin_admin_content' => dirname(__FILE__) . '/config.tpl'));
-$template->assign_var_from_handle('ADMIN_CONTENT', 'plugin_admin_content');
+$template->set_filename('gvideo_content', dirname(__FILE__) . '/template/config.tpl');
 
 ?>
Index: /extensions/gvideo/admin/index.php
===================================================================
--- /extensions/gvideo/admin/index.php	(revision 17306)
+++ /extensions/gvideo/admin/index.php	(revision 17307)
@@ -1,12 +1,9 @@
 <?php
 // +-----------------------------------------------------------------------+
-// | PhpWebGallery - a PHP based picture gallery                           |
-// | Copyright (C) 2002-2003 Pierrick LE GALL - pierrick@phpwebgallery.net |
-// | Copyright (C) 2003-2007 PhpWebGallery Team - http://phpwebgallery.net |
+// | Piwigo - a PHP based photo gallery                                    |
 // +-----------------------------------------------------------------------+
-// | file          : $Id: index.php 1912 2007-03-16 06:30:07Z rub $
-// | last update   : $Date: 2007-03-16 07:30:07 +0100 (ven, 16 mar 2007) $
-// | last modifier : $Author: rub $
-// | revision      : $Revision: 1912 $
+// | Copyright(C) 2008-2012 Piwigo Team                  http://piwigo.org |
+// | Copyright(C) 2003-2008 PhpWebGallery Team    http://phpwebgallery.net |
+// | Copyright(C) 2002-2003 Pierrick LE GALL   http://le-gall.net/pierrick |
 // +-----------------------------------------------------------------------+
 // | This program is free software; you can redistribute it and/or modify  |
Index: /extensions/gvideo/include/functions.inc.php
===================================================================
--- /extensions/gvideo/include/functions.inc.php	(revision 17307)
+++ /extensions/gvideo/include/functions.inc.php	(revision 17307)
@@ -0,0 +1,291 @@
+<?php
+if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');
+
+function parse_video_url($source_url)
+{
+  $source_url = 'http://'.preg_replace('#^http(s?)://#', null, $source_url);
+  
+  $url = parse_url($source_url);
+  $url['host'] = str_replace('www.', null, $url['host']);
+  $url['host'] = explode('.', $url['host']);
+  
+  $video = array();
+  switch ($url['host'][0])
+  {
+    /* youtube */
+    case 'youtube':
+    {
+      $video['type'] = 'youtube';
+
+      parse_str($url['query'], $url['query']);
+      if (empty($url['query']['v'])) return false;
+      
+      $video['id'] = $url['query']['v'];
+    }
+    
+    case 'youtu': // youtu.be (short-url service)
+    {
+      if (empty($video))
+      {
+        $video['type'] = 'youtube';
+        
+        $url['path'] = explode('/', $url['path']);
+        $video['id'] = $url['path'][1];
+      }
+      
+      $api_url = 'http://gdata.youtube.com/feeds/api/videos/'.$video['id'].'?v=2&alt=json';
+      $json = download_remote_file($api_url, true);
+      if ($json === false or $json == 'file_error') return false;
+      
+      $json = json_decode($json, true);
+      $video = array_merge($video, array(
+        'title' => $json['entry']['title']['$t'],
+        'description' => $json['entry']['media$group']['media$description']['$t'],
+        'thumbnail' => $json['entry']['media$group']['media$thumbnail'][2]['url'],
+        'author' => $json['entry']['author'][0]['name']['$t'],
+        ));
+      break;
+    }
+      
+    /* vimeo */
+    case 'vimeo':
+    {
+      $video['type'] = 'vimeo';
+      
+      $url['path'] = explode('/', $url['path']);
+      $video['id'] = $url['path'][1];
+      
+      $api_url = 'http://vimeo.com/api/v2/video/'.$video['id'].'.json';
+      $json = download_remote_file($api_url, true);
+      if ($json === false or $json == 'file_error') return false;
+      
+      $json = json_decode($json, true);
+      $video = array_merge($video, array(
+        'title' => $json[0]['title'],
+        'description' => $json[0]['description'],
+        'thumbnail' => $json[0]['thumbnail_large'],
+        'author' => $json[0]['user_name'],
+        ));
+      break;
+    }
+      
+    /* dailymotion */
+    case 'dailymotion':
+    {
+      $video['type'] = 'dailymotion';
+      
+      $url['path'] = explode('/', $url['path']);
+      if ($url['path'][1] != 'video') return false;
+      $video['id'] = $url['path'][2];
+      
+      $api_url = 'https://api.dailymotion.com/video/'.$video['id'].'?fields=description,id,thumbnail_large_url,title,owner.username'; // DM doesn't accept non secure connection
+      $json = download_remote_file($api_url, true);
+      if ($json === false or $json == 'file_error') return false;
+      
+      $json = json_decode($json, true);
+      $json['thumbnail_large_url'] = preg_replace('#\?([0-9]+)$#', null, $json['thumbnail_large_url']);
+      
+      $video = array_merge($video, array(
+        'id' => $json['id'],
+        'title' => $json['title'],
+        'description' => $json['description'],
+        'thumbnail' => $json['thumbnail_large_url'],
+        'author' => $json['owner.username'],
+        ));
+      break;
+    }
+      
+    /* wat */
+    case 'wat':
+    {
+      $video['type'] = 'wat';
+      
+      $html = download_remote_file($source_url, true);
+      if ($html === false or $html == 'file_error') return false;
+      
+      preg_match('#<meta property="og:video" content="http://www.wat.tv/swf2/([^"/>]+)" />#', $html, $matches);
+      if (empty($matches[1])) return false;
+      $video['id'] = $matches[1];
+      
+      preg_match('#<meta name="name" content="([^">]*)" />#', $html, $matches);
+      $video['title'] = $matches[1];
+      
+      preg_match('#<p class="description"([^>]*)>(.*?)</p>#s', $html, $matches);
+      $video['description'] = $matches[2];
+      
+      preg_match('#<meta property="og:image" content="([^">]+)" />#', $html, $matches);
+      $video['thumbnail'] = $matches[1];
+      
+      $video['author'] = null;
+      break;
+    }
+      
+    /* wideo */
+    case 'wideo':
+    {
+      $video['type'] = 'wideo';
+      
+      $url['path'] = explode('/', $url['path']);
+      $video['id'] = rtrim($url['path'][2], '.html');
+      
+      $html = download_remote_file($source_url, true);
+      if ($html === false or $html == 'file_error') return false;
+            
+      preg_match('#<meta property="og:title" content="([^">]*)" />#', $html, $matches);
+      $video['title'] = $matches[1];
+      
+      preg_match('#<meta property="og:description" content="([^">]*)" />#', $html, $matches);
+      $video['description'] = $matches[1];
+      
+      preg_match('#<meta property="og:image" content="([^">]+)" />#', $html, $matches);
+      $video['thumbnail'] = $matches[1];
+      
+      preg_match('#<li id="li_author">Auteur :  <a href="\#"([^>]*)><span>(.*?)</span></a>#', $html, $matches);
+      $video['author'] = $matches[2];
+      break;
+    }
+      
+    /* videobb */
+    case 'videobb':
+    {
+      $video['type'] = 'videobb';
+      
+      if (!empty($url['query']))
+      {
+        parse_str($url['query'], $url['query']);
+        if (empty($url['query']['v'])) return false;
+        $video['id'] = $url['query']['v'];
+      }
+      else
+      {
+        $url['path'] = explode('/', $url['path']);
+        if ($url['path'][1] != 'video') return false;
+        $video['id'] = $url['path'][2];
+      }
+      
+      $html = download_remote_file($source_url, true);
+      if ($html === false or $html == 'file_error') return false;
+            
+      preg_match('#<meta content="videobb - ([^">]*)"  name="title" property="" />#', $html, $matches);
+      $video['title'] = $matches[1];
+      
+      $video['description'] = null;
+      
+      preg_match('#<link rel="image_src" href="([^">]+)" type="image/jpeg" />#', $html, $matches);
+      $video['thumbnail'] = $matches[1];
+      
+      $video['author'] = null;
+      break;
+    }
+      
+    default:
+      return false;   
+  }
+  
+  return $video;
+}
+
+/**
+ * download a remote file
+ *  - needs cURL or allow_url_fopen
+ *  - take care of SSL urls
+ *
+ * @param: string source url
+ * @param: mixed destination file (if true, file content is returned)
+ */
+if (!function_exists('download_remote_file'))
+{
+  function download_remote_file($src, $dest)
+  {
+    if (empty($src))
+    {
+      return false;
+    }
+    
+    $return = ($dest === true) ? true : false;
+    
+    /* curl */
+    if (function_exists('curl_init'))
+    {
+      if (!$return)
+      {
+        $newf = fopen($dest, "wb");
+      }
+      $ch = curl_init();
+      
+      curl_setopt($ch, CURLOPT_URL, $src);
+      curl_setopt($ch, CURLOPT_HEADER, 0);
+      curl_setopt($ch, CURLOPT_HTTPHEADER, array("Accept-language: en"));
+      curl_setopt($ch, CURLOPT_USERAGENT, 'Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 5.1)');
+      curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
+      curl_setopt($ch, CURLOPT_MAXREDIRS, 1);
+      if (strpos($src, 'https://') !== false)
+      {
+        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
+        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
+      }
+      if (!$return)
+      {
+        curl_setopt($ch, CURLOPT_FILE, $newf);
+      }
+      else
+      {
+        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
+      }
+      
+      if (($out = curl_exec($ch)) === false)
+      {
+        return 'file_error';
+      }
+      
+      curl_close($ch);
+      
+      if (!$return)
+      {
+        fclose($newf);
+        return true;
+      }
+      else
+      {
+        return $out;
+      }
+    }
+    /* file get content */
+    else if (ini_get('allow_url_fopen'))
+    {
+      if (strpos($src, 'https://') !== false and !extension_loaded('openssl'))
+      {
+        return false;
+      }
+      
+      $opts = array(
+        'http' => array(
+          'method' => "GET",
+          'user_agent' => 'Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 5.1)',
+          'header' => "Accept-language: en",
+        )
+      );
+
+      $context = stream_context_create($opts);
+      
+      if (($file = file_get_contents($src, false, $context)) === false)
+      {
+        return 'file_error';
+      }
+      
+      if (!$return)
+      {
+        file_put_contents($dest, $file);
+        return true;
+      }
+      else
+      {
+        return $file;
+      }
+    }
+    
+    return false;
+  }
+}
+
+?>
Index: /extensions/gvideo/include/gvideo.inc.php
===================================================================
--- /extensions/gvideo/include/gvideo.inc.php	(revision 17307)
+++ /extensions/gvideo/include/gvideo.inc.php	(revision 17307)
@@ -0,0 +1,93 @@
+<?php
+if (!defined('GVIDEO_PATH')) die('Hacking attempt!');
+
+/**
+ * replace content on picture page
+ */
+function gvideo_element_content($content, $element_info)
+{
+  global $page, $picture, $template, $conf;
+  
+  $query = '
+SELECT *
+  FROM '.GVIDEO_TABLE.'
+  WHERE picture_id = '.$element_info['id'].'
+;';
+  $result = pwg_query($query);
+  
+  if (!pwg_db_num_rows($result))
+  {
+    return $content;
+  }
+  
+  remove_event_handler('render_element_content', 'default_picture_content', EVENT_HANDLER_PRIORITY_NEUTRAL);
+  
+  $conf['gvideo'] = unserialize($conf['gvideo']);
+  
+  $video = pwg_db_fetch_assoc($result);  
+  if (empty($video['width']))
+  {
+    $video['width'] = $conf['gvideo']['width'];
+    $video['height'] = $conf['gvideo']['height'];
+  }
+  if (empty($video['autoplay']))
+  {
+    $video['autoplay'] = $conf['gvideo']['autoplay'];
+  }
+  
+  $video['config'] = $conf['gvideo'];
+  if ($video['type'] == 'dailymotion')
+  {
+    $colors = array(
+      'F7FFFD' => 'foreground=%23F7FFFD&amp;highlight=%23FFC300&amp;background=%23171D1B',
+      'E02C72' => 'foreground=%23E02C72&amp;highlight=%23BF4B78&amp;background=%23260F18',
+      '92ADE0' => 'foreground=%2392ADE0&amp;highlight=%23A2ACBF&amp;background=%23202226',
+      'E8D9AC' => 'foreground=%23E8D9AC&amp;highlight=%23FFF6D9&amp;background=%23493D27',
+      'C2E165' => 'foreground=%23C2E165&amp;highlight=%23809443&amp;background=%23232912',
+      '052880' => 'foreground=%23FF0099&amp;highlight=%23C9A1FF&amp;background=%23052880',
+      'FF0000' => 'foreground=%23FF0000&amp;highlight=%23FFFFFF&amp;background=%23000000',
+      '834596' => 'foreground=%23834596&amp;highlight=%23CFCFCF&amp;background=%23000000',
+      );
+    $video['config']['dailymotion']['color'] = $colors[ $video['config']['dailymotion']['color'] ];
+  }
+  $template->assign('GVIDEO', $video);
+
+  $template->set_filename('gvideo_content', dirname(__FILE__).'/../template/video_'.$video['type'].'.tpl');
+  return $template->parse('gvideo_content', true);
+}
+
+/**
+ * clean table at element deletion
+ */
+function gvideo_delete_elements($ids)
+{
+  $query = '
+DELETE FROM '.GVIDEO_TABLE.'
+  WHERE picture_id IN ('.implode(',', $ids).')
+;';
+  pwg_query($query);
+}
+
+/**
+ * add message on edition page
+ */
+function gvideo_photo_edit()
+{
+  global $page;
+  
+  if ($page['page'] != 'photo') return;
+  
+  $query = '
+SELECT *
+  FROM '.GVIDEO_TABLE.'
+  WHERE picture_id = '.$_GET['image_id'].'
+;';
+  $result = pwg_query($query);
+  
+  if (pwg_db_num_rows($result))
+  {
+    array_push($page['warnings'], l10n('This element is a video added with "Embedded Video"'));
+  }
+}
+
+?>
Index: /extensions/gvideo/include/index.php
===================================================================
--- /extensions/gvideo/include/index.php	(revision 17307)
+++ /extensions/gvideo/include/index.php	(revision 17307)
@@ -0,0 +1,30 @@
+<?php
+// +-----------------------------------------------------------------------+
+// | Piwigo - a PHP based photo gallery                                    |
+// +-----------------------------------------------------------------------+
+// | Copyright(C) 2008-2012 Piwigo Team                  http://piwigo.org |
+// | Copyright(C) 2003-2008 PhpWebGallery Team    http://phpwebgallery.net |
+// | Copyright(C) 2002-2003 Pierrick LE GALL   http://le-gall.net/pierrick |
+// +-----------------------------------------------------------------------+
+// | This program is free software; you can redistribute it and/or modify  |
+// | it under the terms of the GNU General Public License as published by  |
+// | the Free Software Foundation                                          |
+// |                                                                       |
+// | This program is distributed in the hope that it will be useful, but   |
+// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
+// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
+// | General Public License for more details.                              |
+// |                                                                       |
+// | You should have received a copy of the GNU General Public License     |
+// | along with this program; if not, write to the Free Software           |
+// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
+// | USA.                                                                  |
+// +-----------------------------------------------------------------------+
+
+// Recursive call
+$url = '../';
+header( 'Request-URI: '.$url );
+header( 'Content-Location: '.$url );
+header( 'Location: '.$url );
+exit();
+?>
Index: /extensions/gvideo/index.php
===================================================================
--- /extensions/gvideo/index.php	(revision 17306)
+++ /extensions/gvideo/index.php	(revision 17307)
@@ -1,12 +1,9 @@
 <?php
 // +-----------------------------------------------------------------------+
-// | PhpWebGallery - a PHP based picture gallery                           |
-// | Copyright (C) 2002-2003 Pierrick LE GALL - pierrick@phpwebgallery.net |
-// | Copyright (C) 2003-2007 PhpWebGallery Team - http://phpwebgallery.net |
+// | Piwigo - a PHP based photo gallery                                    |
 // +-----------------------------------------------------------------------+
-// | file          : $Id: index.php 1912 2007-03-16 06:30:07Z rub $
-// | last update   : $Date: 2007-03-16 07:30:07 +0100 (ven, 16 mar 2007) $
-// | last modifier : $Author: rub $
-// | revision      : $Revision: 1912 $
+// | Copyright(C) 2008-2012 Piwigo Team                  http://piwigo.org |
+// | Copyright(C) 2003-2008 PhpWebGallery Team    http://phpwebgallery.net |
+// | Copyright(C) 2002-2003 Pierrick LE GALL   http://le-gall.net/pierrick |
 // +-----------------------------------------------------------------------+
 // | This program is free software; you can redistribute it and/or modify  |
Index: /extensions/gvideo/language/ar_SA/index.php
===================================================================
--- /extensions/gvideo/language/ar_SA/index.php	(revision 17306)
+++ /extensions/gvideo/language/ar_SA/index.php	(revision 17307)
@@ -1,12 +1,9 @@
 <?php
 // +-----------------------------------------------------------------------+
-// | PhpWebGallery - a PHP based picture gallery                           |
-// | Copyright (C) 2002-2003 Pierrick LE GALL - pierrick@phpwebgallery.net |
-// | Copyright (C) 2003-2007 PhpWebGallery Team - http://phpwebgallery.net |
+// | Piwigo - a PHP based photo gallery                                    |
 // +-----------------------------------------------------------------------+
-// | file          : $Id$
-// | last update   : $Date$
-// | last modifier : $Author$
-// | revision      : $Revision$
+// | Copyright(C) 2008-2012 Piwigo Team                  http://piwigo.org |
+// | Copyright(C) 2003-2008 PhpWebGallery Team    http://phpwebgallery.net |
+// | Copyright(C) 2002-2003 Pierrick LE GALL   http://le-gall.net/pierrick |
 // +-----------------------------------------------------------------------+
 // | This program is free software; you can redistribute it and/or modify  |
Index: /extensions/gvideo/language/ca_ES/index.php
===================================================================
--- /extensions/gvideo/language/ca_ES/index.php	(revision 17307)
+++ /extensions/gvideo/language/ca_ES/index.php	(revision 17307)
@@ -0,0 +1,30 @@
+<?php
+// +-----------------------------------------------------------------------+
+// | Piwigo - a PHP based photo gallery                                    |
+// +-----------------------------------------------------------------------+
+// | Copyright(C) 2008-2012 Piwigo Team                  http://piwigo.org |
+// | Copyright(C) 2003-2008 PhpWebGallery Team    http://phpwebgallery.net |
+// | Copyright(C) 2002-2003 Pierrick LE GALL   http://le-gall.net/pierrick |
+// +-----------------------------------------------------------------------+
+// | This program is free software; you can redistribute it and/or modify  |
+// | it under the terms of the GNU General Public License as published by  |
+// | the Free Software Foundation                                          |
+// |                                                                       |
+// | This program is distributed in the hope that it will be useful, but   |
+// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
+// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
+// | General Public License for more details.                              |
+// |                                                                       |
+// | You should have received a copy of the GNU General Public License     |
+// | along with this program; if not, write to the Free Software           |
+// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
+// | USA.                                                                  |
+// +-----------------------------------------------------------------------+
+
+// Recursive call
+$url = '../';
+header( 'Request-URI: '.$url );
+header( 'Content-Location: '.$url );
+header( 'Location: '.$url );
+exit();
+?>
Index: /extensions/gvideo/language/cs_CZ/index.php
===================================================================
--- /extensions/gvideo/language/cs_CZ/index.php	(revision 17306)
+++ /extensions/gvideo/language/cs_CZ/index.php	(revision 17307)
@@ -1,12 +1,9 @@
 <?php
 // +-----------------------------------------------------------------------+
-// | PhpWebGallery - a PHP based picture gallery                           |
-// | Copyright (C) 2002-2003 Pierrick LE GALL - pierrick@phpwebgallery.net |
-// | Copyright (C) 2003-2007 PhpWebGallery Team - http://phpwebgallery.net |
+// | Piwigo - a PHP based photo gallery                                    |
 // +-----------------------------------------------------------------------+
-// | file          : $Id$
-// | last update   : $Date$
-// | last modifier : $Author$
-// | revision      : $Revision$
+// | Copyright(C) 2008-2012 Piwigo Team                  http://piwigo.org |
+// | Copyright(C) 2003-2008 PhpWebGallery Team    http://phpwebgallery.net |
+// | Copyright(C) 2002-2003 Pierrick LE GALL   http://le-gall.net/pierrick |
 // +-----------------------------------------------------------------------+
 // | This program is free software; you can redistribute it and/or modify  |
